<script>
export default {
  props: {
    data: {
      type: Object,
      required: true,
    },
    styles: {
      type: Object,
      required: false,
      default: () => ({
        container: {},
        header: {},
        cards: {},
        card: {},
        title: {},
        text: {},
        icon: {},
      }),
    },
  },
  computed: {
    // Styles coming from customFields in CMS
    computedStyles() {
      return {
        container: {
          ...this.styles?.container,
          ...this.data.styles?.container,
        },
        header: {
          ...this.styles?.header,
          ...this.data.styles?.header,
        },
        cards: {
          ...this.styles?.cards,
          ...this.data.styles?.cards,
        },
        card: {
          ...this.styles?.card,
          ...this.data.styles?.card,
        },
        title: {
          ...this.styles?.title,
          ...this.data.styles?.title,
        },
        text: {
          ...this.styles?.text,
          ...this.data.styles?.text,
        },
        icon: {
          ...this.styles?.icon,
          ...this.data.styles?.icon,
        },
      };
    },
  },
};
</script>

<template>
  <div
    :id="data.id || data.metadata?.blockId || ''"
    class="container"
    :style="computedStyles.container"
  >
    <div class="container__wrapper">
      <SlpTypography
        v-if="data.header"
        tag="h2"
        variant="heading2-bold"
        :style="computedStyles.header"
        class="container__header"
        :class="{
          'container__header--no-margin': data.no_margin_header,
        }"
        >{{ data.header }}</SlpTypography
      >
      <div
        v-if="data.cards"
        class="container__cards"
        :style="computedStyles.cards"
      >
        <div
          v-for="card in data.cards"
          :key="card.text"
          class="card"
          :style="computedStyles.card"
        >
          <SlpIcon
            v-if="card.iconName"
            :name="card.iconName || 'devsecops'"
            variant="marketing"
            :slp-color="computedStyles.icon?.color || 'accent-400'"
            size="md"
            class="slp-mb-16"
            :style="computedStyles.icon"
          />
          <SlpTypography
            tag="p"
            variant="body1-bold"
            :style="computedStyles.title"
            class="card__title"
            >{{ card.title }}</SlpTypography
          >
          <SlpTypography tag="p" variant="body2" :style="computedStyles.text">{{
            card.description
          }}</SlpTypography>
        </div>
      </div>
      <SlpButton
        v-if="data.cta"
        variant="tertiary"
        :href="data.cta?.url"
        :data-ga-name="data.cta?.dataGaName"
        :data-ga-location="data.cta?.dataGaLocation"
        class="slp-mt-32"
      >
        {{ data.cta.text }}
        <SlpIcon name="chevron-lg-right" variant="product" />
      </SlpButton>
      <SlpTypography
        v-if="data.description"
        class="container__cta"
        tag="div"
        variant="heading4"
      >
        <div v-html="$md.render(data.description)"></div>
      </SlpTypography>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.container {
  background-color: $color-surface-700;
  color: #fff;
  padding: $spacing-32 $spacing-16;

  &__wrapper {
    max-width: 1135px;
    margin: 0 auto;
  }

  &__header {
    margin: $spacing-32 0;

    @media (min-width: $breakpoint-lg) {
      margin: 80px 0;
      max-width: 80%;

      &--no-margin {
        margin: 0;
      }
    }

    &--no-margin {
      margin: 0;
    }
  }

  &__cards {
    display: grid;
    grid-template-columns: repeat(3, 1fr);

    @media (max-width: $breakpoint-md) {
      grid-template-columns: 1fr;
    }
  }

  &__cta {
    margin-top: $spacing-96;
  }

  .card {
    width: 100%;
    margin-top: $spacing-32;

    @media (max-width: $breakpoint-md) {
      margin-top: $spacing-16;
    }

    @media (min-width: $breakpoint-lg) {
      max-width: 330px;
    }

    &__title {
      margin-bottom: $spacing-16;
    }
  }
}
</style>
